<?php
declare (strict_types=1);

namespace App\Entity\Billing;

use ApiPlatform\Metadata\Post;
use ApiPlatform\Metadata\GetCollection;
use ApiPlatform\Metadata\Delete;
use ApiPlatform\Metadata\Put;
use ApiPlatform\Metadata\Get;
use ApiPlatform\Metadata\ApiResource;
use App\Attribute\BillingSettingDefaultValue;
use App\Entity\Product\IntangibleDiscountDetail;
use App\Repository\Billing\ResidenceAreaRepository;
//use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\Collection;

/**
 * Zone de résidence d'un Access, telle que définie par l'Organization
 */
#[ApiResource(
    operations: [
        new Get(
            security: 'is_granted(\'ROLE_ORGANIZATION_VIEW\') and object.getBillingSetting().getOrganization().getId() == user.getOrganization().getId()'
        ),
        new Put(
            security: 'object.getBillingSetting().getOrganization().getId() == user.getOrganization().getId()'
        ),
        new Delete(
            security: 'object.getBillingSetting().getOrganization().getId() == user.getOrganization().getId()'
        ),
        new GetCollection(
            security: 'is_granted(\'ROLE_ORGANIZATION_VIEW\')'
        ),
        new Post()
    ],
    security: 'is_granted(\'ROLE_ORGANIZATION\')'
)]
//#[Auditable]
#[BillingSettingDefaultValue(fieldName: "billingSetting")]
#[ORM\Entity(repositoryClass: ResidenceAreaRepository::class)]
class ResidenceArea
{
    #[ORM\Id]
    #[ORM\Column]
    #[ORM\GeneratedValue]
    private ?int $id = null;

    #[ORM\ManyToOne(targetEntity: BillingSetting::class, inversedBy: 'residenceAreas')]
    #[ORM\JoinColumn(nullable: false)]
    private BillingSetting $billingSetting;

    #[ORM\OneToMany(mappedBy: 'residenceArea', targetEntity: AccessBilling::class)]
    private Collection $accessBilling;

    #[ORM\OneToMany(mappedBy: 'residenceArea', targetEntity: IntangibleDiscountDetail::class)]
    private Collection $intangibleDiscountDetails;

    #[ORM\Column(length: 255)]
    private string $label;

    public function __construct()
    {
        $this->accessBilling = new ArrayCollection();
        $this->intangibleDiscountDetails = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLabel(): string
    {
        return $this->label;
    }

    public function setLabel(string $label): self
    {
        $this->label = $label;
        return $this;
    }

    public function getBillingSetting(): ?BillingSetting
    {
        return $this->billingSetting;
    }

    public function setBillingSetting(?BillingSetting $billingSetting): self
    {
        $this->billingSetting = $billingSetting;
        return $this;
    }

    /**
     * @return Collection<int, AccessBilling>
     */
    public function getAccessBilling(): Collection
    {
        return $this->accessBilling;
    }

    public function addAccessBilling(AccessBilling $accessBilling): self
    {
        if (!$this->accessBilling->contains($accessBilling)) {
            $this->accessBilling[] = $accessBilling;
            $accessBilling->setResidenceArea($this);
        }
        return $this;
    }

    public function removeAccessBilling(AccessBilling $accessBilling): self
    {
        if ($this->accessBilling->removeElement($accessBilling)) {
            // set the owning side to null (unless already changed)
            if ($accessBilling->getResidenceArea() === $this) {
                $accessBilling->setResidenceArea(null);
            }
        }
        return $this;
    }

    /**
     * @return Collection<int, IntangibleDiscountDetail>
     */
    public function getIntangibleDiscountDetails(): Collection
    {
        return $this->intangibleDiscountDetails;
    }

    public function addIntangibleDiscountDetail(IntangibleDiscountDetail $intangibleDiscountDetail): self
    {
        if (!$this->intangibleDiscountDetails->contains($intangibleDiscountDetail)) {
            $this->intangibleDiscountDetails[] = $intangibleDiscountDetail;
            $intangibleDiscountDetail->setResidenceArea($this);
        }
        return $this;
    }

    public function removeIntangibleDiscountDetail(IntangibleDiscountDetail $intangibleDiscountDetail): self
    {
        if ($this->intangibleDiscountDetails->removeElement($intangibleDiscountDetail)) {
            // set the owning side to null (unless already changed)
            if ($intangibleDiscountDetail->getResidenceArea() === $this) {
                $intangibleDiscountDetail->setResidenceArea(null);
            }
        }
        return $this;
    }
}
